"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var createApiCaller_1 = require("./createApiCaller");
var defaults_1 = require("./defaults");
var createFilterReducer = function (options) {
    return function (state, action) {
        if (action.type == "FILTER/IMPORT_ENTITIES") {
            return state;
        }
        var filterName = action.filterName;
        var callApi = createApiCaller_1.default(filterName);
        if (action.type == "FILTER/INPUT_CHANGED") {
            var oldInput = state.lastApplied ? state.lastApplied.input :
                state.lastEntered ? state.lastEntered.input : {};
            return callApi(state, __assign(__assign({}, (state.lastApplied || state.lastEntered || defaults_1.defaultSpecs)), { pageIndex: 0, input: __assign(__assign({}, oldInput), action.changes) }), options);
        }
        else if (action.type == "FILTER/PAGE_INDEX_CHANGED") {
            return callApi(state, __assign(__assign({}, (state.lastApplied || state.lastEntered || defaults_1.defaultSpecs)), { pageIndex: action.index }), options);
        }
        else if (action.type == "FILTER/PAGE_SIZE_CHANGED") {
            return callApi(state, __assign(__assign({}, (state.lastApplied || state.lastEntered || defaults_1.defaultSpecs)), { pageIndex: 0, pageSize: action.size }), options);
        }
        else if (action.type == "FILTER/REFRESH") {
            return callApi(state, __assign({}, (state.lastApplied || state.lastEntered || defaults_1.defaultSpecs)), options);
        }
        else if (action.type == "FILTER/SORT_BY_CHANGED") {
            var sortByDescending = false;
            if (state.lastApplied && state.lastApplied.sortBy == action.path) {
                var oldDescending = state.lastApplied
                    ? !!state.lastApplied.sortByDescending
                    : true;
                sortByDescending = action.descending !== undefined
                    ? action.descending : !oldDescending;
            }
            return callApi(state, __assign(__assign({}, (state.lastApplied || state.lastEntered || defaults_1.defaultSpecs)), { pageIndex: 0, sortBy: action.path, sortByDescending: sortByDescending }), options);
        }
        else if (action.type == "FILTER/REQUEST_SUCCESS") {
            var request = action.request, payload = action.payload;
            return state.lastRequest === request
                ? __assign(__assign({}, state), { matches: payload.matches, isLoading: false, lastApplied: request, total: payload.total, matchKeys: payload.matchKeys }) : state;
        }
        else if (action.type == "FILTER/REQUEST_ERROR") {
            var payload = action.payload, request = action.request;
            return state.lastRequest === request
                ? __assign(__assign({}, state), { isLoading: false, error: payload }) : state;
        }
        else
            return state;
    };
};
exports.default = createFilterReducer;
