"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var redux_1 = require("redux");
var normalizr_1 = require("normalizr");
var redux_loop_1 = require("redux-loop");
// test api(s)
var mockBackend_1 = require("../services/mockBackend");
var testData_1 = require("../services/mockBackend/testData");
// reducer(s)
var index_1 = require("../index");
var dataNormalizers_1 = require("./dataNormalizers");
var contactApi = mockBackend_1.contactMemoryApi(1000, testData_1.contacts);
// setup data reducer and query api(s)
var dataReducer = index_1.createDataReducer({
    apiMap: {
        //contactsAutoComplete: (specs) => 
        //    contactApi.autoComplete(specs).then(results => {
        //        const n = normalize(results.matches, [contactEntity]);
        //        return {
        //            total: results.total,
        //            matchKeys: n.result,
        //            entities: n.entities
        //        };
        //    }),
        getContactById: function (specs) {
            return contactApi.findByKey(specs.input.key || "").then(function (result) {
                var n = normalizr_1.normalize(result, dataNormalizers_1.contactEntity);
                return {
                    total: 1,
                    matchKeys: n.result,
                    entities: n.entities
                };
            });
        }
    }
});
// create app store
var reducer = redux_loop_1.combineReducers({
    dataFilters: dataReducer
});
exports.store = redux_1.createStore(reducer, undefined, redux_loop_1.install());
// mount application
//ReactDOM.render(<App store={store} />, document.getElementById("root"));
