"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = require("react");
var redux_react_hook_1 = require("redux-react-hook");
var defaults_1 = require("./defaults");
var none = {};
function getValue(e) {
    return (e && e.target) ? e.target.value : e;
}
exports.default = (function (stateSelector) {
    return function (filterName, _a) {
        var initialQuery = _a.initialQuery, searchApi = _a.searchApi, applyInitialQuery = _a.applyInitialQuery, keepMounted = _a.keepMounted;
        var mappedState = react_1.useCallback(function (s) {
            return stateSelector(s).mounted[filterName];
        }, [filterName]);
        var m = redux_react_hook_1.useMappedState(mappedState);
        var dispatch = redux_react_hook_1.useDispatch();
        react_1.useEffect(function () {
            dispatch({
                type: "FILTER/MOUNT",
                filterName: filterName,
                options: { initialQuery: initialQuery, applyInitialQuery: applyInitialQuery, keepMounted: keepMounted }
            });
            return function () {
                if (!keepMounted)
                    dispatch({ type: "FILTER/UNMOUNT", filterName: filterName });
            };
        }, [filterName]);
        var getFilterValue = function (name, defaultValue) {
            return m ? (m.lastRequest
                ? m.lastRequest.input[name] || defaultValue
                : defaultValue) : defaultValue;
        };
        var actions = {
            refresh: function () { return dispatch({
                type: "FILTER/REFRESH",
                filterName: filterName
            }); },
            setInput: function (changes) { return dispatch({
                type: "FILTER/INPUT_CHANGED",
                changes: changes,
                filterName: filterName
            }); },
            setPageIndex: function (index) { return dispatch({
                type: "FILTER/PAGE_INDEX_CHANGED",
                index: index,
                filterName: filterName
            }); },
            setPageSize: function (size) { return dispatch({
                type: "FILTER/PAGE_SIZE_CHANGED",
                size: size,
                filterName: filterName
            }); },
            setSortBy: function (path, descending) { return dispatch({
                type: "FILTER/SORT_BY_CHANGED",
                path: path,
                descending: descending,
                filterName: filterName
            }); }
        };
        return __assign(__assign(__assign({}, (m || defaults_1.defaultFilterState)), actions), { getFilterValue: getFilterValue, getFilterInputProps: function (name, defaultValue) { return ({
                name: name,
                disabled: false,
                value: getFilterValue(name, defaultValue),
                onChange: function (e) {
                    var _a;
                    return actions.setInput((_a = {}, _a[name] = getValue(e), _a));
                }
            }); } });
    };
});
